﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Spread.Common.DataStore
{
    public class AccessDataSource
    {
        internal AccessDataSource() { }

        private string GetDBPath(string dbName)
        {
            string dbPath = string.Empty;
            string fileName = string.Format("\\{0}",dbName);
            RegistryKey regKey = Registry.ClassesRoot.OpenSubKey("FarPoint.Win.Spread\\Common7");
            if (regKey != null)
                dbPath = (string)regKey.GetValue("v" + GCVersionUtil.ProductVersion);
            if (!File.Exists(dbPath + fileName))
                dbPath = Environment.GetFolderPath(Environment.SpecialFolder.ProgramFiles) + GCVersionUtil.SPREAD_INSTALLATION_FOLDER + "\\Common\\";
            if (!File.Exists(dbPath + fileName))
                dbPath = "Data\\";
            dbPath += fileName;
            return dbPath;
        }

        public DataSet GetNWINDData(string dataTable)
        {
            string sqlStr = string.Format("Select*From `{0}`", dataTable);
            return GetNWINDDataComplete(sqlStr);
        }

        public DataSet GetNWINDDataComplete(string query)
        {
            return GetDataFrom("Nwind.mdb", query);
        }

        public DataSet GetDataFrom(string dbName,string query)
        {
            string conStr = "Provider=Microsoft.JET.OLEDB.4.0;data source=" + GetDBPath(dbName);
            System.Data.OleDb.OleDbConnection conn = new System.Data.OleDb.OleDbConnection(conStr);
            DataSet ds = new DataSet();
            System.Data.OleDb.OleDbDataAdapter da = new System.Data.OleDb.OleDbDataAdapter(query, conn);
            da.Fill(ds);
            return ds;
        }

        public DataSet GetDataFromTable(string dbName,string dataTable)
        {
            string sqlStr = string.Format("Select * From `{0}`", dataTable);
            return GetDataFrom(dbName, sqlStr);
        }
    }


}
