﻿using Spread.Common.DataStore.Model;
using System;
using System.Linq;

namespace Spread.Common.DataStore.DataSourceEntities
{
    public class COGSDataSource
    {
        #region Public methods
        public CostOfGoodsStats GetCOGSStats(DateTime seedDate, int revenueCategoryCount, int costCategoryCount)
        {
            Random random = new Random((int)seedDate.ToOADate());
            CostOfGoodsStats stats = new CostOfGoodsStats();

            for (int i = 0; i < revenueCategoryCount; ++i)
                stats.CategoryRevenues.Add(random.Next(120000, 250000));

            for (int i = 0; i < costCategoryCount; ++i)
                stats.CategoryCosts.Add(random.Next(50000, 160000));

            stats.Expenses.SalaryExpenses = random.Next(40000, 60000);
            stats.Expenses.PayrollExpenses = random.Next(5000, 10000);
            stats.Expenses.OutsideServices = random.Next(4000, 7000);
            stats.Expenses.Supplies = random.Next(10000, 15000);
            stats.Expenses.Repairs = random.Next(2000, 5000);
            stats.Expenses.Advertising = random.Next(5000, 10000);
            stats.Expenses.CarDelivery = random.Next(1000, 3000);
            stats.Expenses.Accounting = random.Next(2000, 4000);
            stats.Expenses.Rent = random.Next(10000, 13000);
            stats.Expenses.Telephone = random.Next(3000, 4000);
            stats.Expenses.Utilities = random.Next(2000, 4000);
            stats.Expenses.Insurance = random.Next(3000, 4000);
            stats.Expenses.Taxes = (int)(0.17 * stats.CategoryRevenues.Sum());
            stats.Expenses.Interest = random.Next(1000, 2000);
            stats.Expenses.Depreciation = random.Next(500, 1200);

            for (int i = 0; i < 3; ++i)
                stats.Expenses.Others.Add(random.Next(200, 600));

            stats.Expenses.Miscellaneous = random.Next(1200, 2000);

            return stats;
        }
        #endregion
    }
}
