﻿using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Spread.Common.DataStore.Models;
using Spread.Common.DataStore.Utilities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Spread.Common.DataStore.DataSourceEntities
{
    public class FinancialKPIDataSource
    {
        #region Private methods
        private void UpdateDatesInData(List<FinancialTargetMaster> targetMasterList)
        {
            int currentMonth = DateTime.Now.Month;
            int currentYr = DateTime.Now.Year;

            FinancialTargetMaster sampleTarget = targetMasterList.Last();
            Random random = new Random();

            foreach (var target in targetMasterList.OrderByDescending(t => t.Year).ThenByDescending(t => t.Month))
            {
                target.Month = currentMonth;
                target.Year = currentYr;
                currentMonth--;
                if (currentMonth == 0)
                {
                    currentMonth = 12;
                    currentYr--;
                }
            }
        }
        #endregion

        #region Public methods
        public FinancialKPIList GetAllKPIs()
        {
            string json = FileUtilities.LoadJSON("FinancialKPIList.json");
            FinancialKPIList kpiList = JsonConvert.DeserializeObject<FinancialKPIList>(json);
            return kpiList;
        }

        public List<FinancialTargetMaster> GetAllTargets()
        {
            string json = FileUtilities.LoadJSON("FinancialTargetMaster.json");
            var parsedObject = JObject.Parse(json);
            string financialData = parsedObject["FinancialKPI"].ToString();
            List<FinancialTargetMaster> targetMasterList = JsonConvert.DeserializeObject<List<FinancialTargetMaster>>(financialData);
            UpdateDatesInData(targetMasterList);
            return targetMasterList;
        }
        #endregion
    }
}