﻿using System;

namespace Spread.Common.DataStore.Models
{
    public class BusinessStat
    {
        #region Fields
        private int _month;
        private int _year;
        #endregion

        #region Properties
        public BusinessRevenue Revenue { get; set; }
        public BusinessExpense Expense { get; set; }

        public int Month
        {
            get { return _month; }
            set
            {
                if (value < 1 || value > 12)
                    throw new ArgumentException($"Invalid value for Month.\nExpected value: 1 to 12\nValue: {value}");
                _month = value;
            }
        }

        public int Year
        {
            get  { return _year; }
            set
            {
                if (value < 1000 || value > 9999)
                    throw new ArgumentException($"Invalid value for Year.\nExpected value: 1000 to 9999\n" +
                        $"Value: {value}");
                _year = value;
            }
        }
        #endregion
    }
}
