﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Spread.Common.DataStore.Models
{
    public class KPIList
    {
        public KPIList()
        {
            Items = new Dictionary<int, string>();
        }

        [JsonProperty("BusinessKPIItems")]
        public Dictionary<int, string> Items { get; set; }
    }

    public class KPIMetrics
    {
        public int KPIId { get; set; }
        public double Actual { get; set; }
        public double Target { get; set; }
    }

    public class TargetMaster
    {
        private int _month;
        private int _year;

        public TargetMaster()
        {
            KPITargets = new List<KPIMetrics>();
        }

        public int Month
        {
            get { return _month; }
            set
            {
                if (value < 1 || value > 12)
                    throw new NotSupportedException("Value not supported.\nExpected Value: 1 to 12\nActual Value: " + value);
                _month = value;
            }
        }
        public int Year
        {
            get { return _year; }
            set
            {
                if (value < 1000 || value > 9999)
                    throw new NotSupportedException("Value not supported.\nExpected value 1000 to 9999\nActual value: " + value);
                _year = value;
            }
        }

        [JsonProperty("BusinessKPITargets")]
        public List<KPIMetrics> KPITargets { get; set; }
    }
}
