﻿using System;

namespace Spread.Common.DataStore.Models
{
    public class ScheduleEntry
    {
        public Guid ID { get; }
        public DayOfWeek DayOfWeek { get; }
        public int Hour { get; }
        public string Subject { get; }

        public ScheduleEntry(string subject, DayOfWeek dayOfWeek, int hour)
        {
            ID = Guid.NewGuid();
            DayOfWeek = dayOfWeek;
            Hour = hour;
            Subject = subject;
        }
    }

    public class Assignment
    {
        public Guid ID { get; }
        public DateTime Date { get; set; }
        public string Description { get; }

        public Assignment(DateTime date, string description)
        {
            ID = Guid.NewGuid();
            Date = date;
            Description = description;
        }
    }
}
