﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace Spread.Common.DataStore.Utilities
{
    public class FileUtilities
    {
        const string jsonPath = @".\Data";

        public static string ReadTextFromFile(string filePath)
        {
            var files = Directory.GetFiles(jsonPath);
            if (System.IO.File.Exists(filePath))
            {
                try
                {
                    System.IO.File.SetAttributes(filePath, System.IO.FileAttributes.Normal);
                }
                catch { }
                var text = File.ReadAllText(filePath);
                return text;
            }
            else
            {
                throw new System.IO.FileNotFoundException("File does not exist" + filePath);
            }
        }

        public static void WriteTextToFile(string filePath,string content)
        {
            try
            {
                File.WriteAllText(filePath, content);
            }
            catch(Exception ex)
            {
                throw ex;
            }
        }

        public static string LoadJSON(string fileName)
        {
            var json = string.Empty;
            json = ReadTextFromFile(Path.Combine(jsonPath, fileName));
            return json;
        }

        public static void WriteToJSON(string fileName,string content)
        {
            WriteTextToFile(Path.Combine(jsonPath, fileName), content);
        }
    }
}
