﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Spread.Common.Features.Explorer.CustomControls
{
    public partial class BreadCrumb : UserControl
    {
        public BreadCrumb()
        {
            InitializeComponent();
        }

        public void Path(Dictionary<string, EventHandler> paths)
        {
            this.Clear();
            foreach(var path in paths)
            {
                this.AddPath(path.Key, path.Value);
            }
        }

        public void Clear()
        {
            this.fLP.Controls.Clear();
        }

        public void AddPath(string name, EventHandler clickDelegate)
        {
            var label = new Label
            {
                Text = name,
                Tag = this.fLP.Controls.OfType<Label>().Count(),
                AutoSize = true
            };
            if(this.fLP.Controls.OfType<Label>().Count() != 0)
            {
                label.Text = @"/  " + label.Text;
            }
            label.MouseEnter += (s, e) =>
            {
                this.Cursor = Cursors.Hand;
            };
            label.MouseLeave += (s, e) =>
            {
                this.Cursor = Cursors.Default;
            };
            label.Click += clickDelegate;
            label.Click += (s, e) =>
            {
                var removeControls = this.fLP.Controls.OfType<Label>().Where(
                    l => ((int)(l as Label).Tag) > ((int)(s as Label).Tag)
                ).ToList();
                foreach (var removeControl in removeControls)
                {
                    this.fLP.Controls.Remove(removeControl);
                }
            };
            this.fLP.Controls.Add(label);
        }
    }
}
