﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Spread.Common.Features.Explorer.CustomControls
{
    [System.ComponentModel.DesignerCategory("Code")]
    public class PanelEx : Panel
    {
        bool _ShowBorder = true;
        public bool ShowBorder
        {
            get
            {
                return _ShowBorder;
            }
            set
            {
                _ShowBorder = value;
                this.Invalidate();
            }
        }

        Color _BorderColor = Color.FromArgb(221, 221, 221);
        public Color BorderColor
        {
            get
            {
                return this._BorderColor;
            }
            set
            {
                if (this._BorderColor != value)
                {
                    this._BorderColor = value;
                    Invalidate();
                }
            }
        }
        public PanelEx()
        {
            SetStyle(ControlStyles.UserPaint | ControlStyles.ResizeRedraw | ControlStyles.DoubleBuffer | ControlStyles.AllPaintingInWmPaint, true);
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            if (ShowBorder)
            {
                var rect = new Rectangle(0, 0, this.Width - 1, this.Height - 1);
                e.Graphics.DrawRectangle(new Pen(BorderColor), rect);
            }
        }

    }
}
