﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Spread.ControlExplorer.Components
{
    public class TextBoxEx : TextBox
    {
        const int WmPaint = 15;

        string _Placeholder = "";
        public string Placeholder
        {
            get
            {
                return _Placeholder;
            }
            set
            {
                _Placeholder = value;
                this.Refresh();
            }
        }

        protected override void OnTextChanged(EventArgs e)
        {
            base.OnTextChanged(e);
            this.Refresh();
        }

        protected override void WndProc(ref Message m)
        {
            base.WndProc(ref m);

            switch (m.Msg)
            {
                case WmPaint:
                    using (var graphics = Graphics.FromHwnd(Handle))
                    {
                        if (string.IsNullOrEmpty(this.Text) && !string.IsNullOrEmpty(this.Placeholder))
                        {
                            graphics.DrawString(this.Placeholder, this.Font, Brushes.DimGray, new PointF(0, 0));
                        }
                    }
                    break;
            }
        }
    }
}
