﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Spread.Common.Features.Sample
{
    public partial class BaseSampleControl : UserControl
    {
        private bool ImageMode = false;
        public BaseSampleControl()
        {
            InitializeComponent();
            this.Load += BaseSampleControl_Load;
        }

        private void BaseSampleControl_Load(object sender, EventArgs e)
        {
            if (!DesignMode)
                Dock = DockStyle.Fill;
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            if(!DesignMode)
                rootPanel.Panel2Collapsed = ImageMode || pnlControls.Controls.Count == 0;
            base.OnPaint(e);
        }



        public virtual Image GetImage(int width = 200, int height = 200)
        {
            var bmp = new Bitmap(this.Width, this.Height, System.Drawing.Imaging.PixelFormat.Format32bppArgb);
            ImageMode = true;
            rootPanel.Panel2Collapsed = true;
            this.DrawToBitmap(bmp, this.DisplayRectangle);
            ImageMode = false;
            var thumb = bmp.GetThumbnailImage(width, height, null, IntPtr.Zero);
            return thumb;
        }
    }
}
